/*
 * The NMO core code is under GPL Licence.
 * This doesn't apply automatically to the 3rd party code that uses nmo.
 * Please feel free to licence your own code the way you wish.
 */


/*****************************************************************************
 * NOTE : Please do not alter too much the structure of this file so diff3   *
 *        won't be too much disturbed. The less diff conflicts, the less     *
 *        overhead for you when you regenerate this package.                 *
 *****************************************************************************/


/*****************************************************************************
 * Put here everything you wish to include BEFORE the NMO code              *
 *****************************************************************************/


#ifndef _COLDFIRE_DEFINES_
#define _COLDFIRE_DEFINES_

#define NO_TRACE /* disable trace messages */

#include <stdlib.h>
#define atoi atoi
#include <stdio.h>
#include <math.h>
#include <rtems.h>
#include <chameleon.h>
#include <midishare.h>


#define COMM_INTERVAL 5

#define COMM_PRIO     10
#define NEMO_PRIO     23
#define PANEL_PRIO    17


#define PANELMODE_CLIENT 0
#define PANELMODE_EDIT   1
#define PANELMODE_RUN    2

#define MESSAGE_DURATION 1337
#define MESSAGE_HOLD 730
//#define MESSAGE_HOLD 500

#define SCREENSAVER_TIMEOUT 23023

#define EDIT_TIMEOUT        20

extern rtems_id user_input;
extern rtems_unsigned32 Panel_Mode;


typedef rtems_unsigned16 Input_Message;

#define MkIMsg(what,val) (((what)<<8)|(rtems_unsigned8)(val))
#define MsgWhat(msg) ((msg)>>8)
#define MsgVal(msg) ((rtems_signed8)((msg)&0xFF))
#define MsgSz sizeof(Input_Message)

#define MSG_QUIT        255
#define MSG_MODE_CHANGE   1
#define MSG_PART_UP       2
#define MSG_PART_DOWN     3
#define MSG_GROUP_UP      4
#define MSG_GROUP_DOWN    5
#define MSG_PAGE_UP       6
#define MSG_PAGE_DOWN     7
#define MSG_PARAM_UP      8
#define MSG_PARAM_DOWN    9
#define MSG_VALUE_CHANGE 10
#define MSG_VALUE_UP     11
#define MSG_VALUE_DOWN   12


#define lock(x) rtems_semaphore_obtain(x,RTEMS_WAIT,RTEMS_NO_TIMEOUT)
#define unlock(x) rtems_semaphore_release(x)


//#define midi_loopback()  /*TRACE("MIDI:LOOPBACK\n"); */if(!clock_is_running) MidiSend(refMidi,CLOCK_EV)

#define midi_loopback() rtems_event_send((rtems_id) midi_task, EVENT_MIDI)

#define EVENT_MIDI	RTEMS_EVENT_1
#define EVENT_NOTE	RTEMS_EVENT_2
#define EVENT_CTRL	RTEMS_EVENT_3
#define EVENT_PRG	RTEMS_EVENT_4


extern int volatile clock_is_running;
extern short refMidi;
extern MidiEvPtr CLOCK_EV;

extern rtems_id midi_task;

#endif






/* end of this file ! */
