
#include "coldfire.h"
#include "char_bitmaps.h"
#include <chameleon.h>
#include <panel.h>

/* topright labels */
#define TR_INFO 0
#define TR_NEWC 1
#define TR_NEWG 2
#define TR_NEWM 3
#define TR_DELC 4
#define TR_DELM 5
#define TR_DELG 6
#define TR_LINK 7
#define TR_ULNK 8
/* bogus defines for labels using standard chars */
#define TR_CEL  101 /* cell */
#define TR_MOD  102 /* module */
#define TR_GRP  103 /* group */
#define TR_IN   104 /* input */
#define TR_OUT  105 /* output */
#define TR_REG  106 /* register */
#define TR_PAR  107 /* parameter ("par") */
#define TR_OFS  108 /* offset ("%02u") */

#define CHR_LABEL3_1 1
#define CHR_LABEL3_2 2
#define CHR_LABEL3_3 3
#define STR_LABEL3 "\001\002\003"

#define CHR_EDITLABEL1 4
#define CHR_EDITLABEL2 5
#define CHR_EDITLABEL3 6
#define CHR_EDITLABEL4 7
#define STR_EDITLABEL "\004\005\006\007"
#define CHR_CURSOR 8
#define STR_CURSOR "\010"

#define CHR_LRG 4
#define CHR_LST 5
#define CHR_B1  6
#define CHR_B0  7

int disp_init();
void display(int x,int y,char*text,...);
void display_message(char*text,...);
void set_cursor(int x,int y);
void disable_cursor();
void enable_cursor();
void set_chr(int c,rtems_unsigned8 const*bm);
void raw_set_chr(int c,rtems_unsigned8 const*bm);
void refresh();
void redraw();
void clear();
void invalidate_screen();

extern int volatile panel_input_disabled;

extern rtems_id disp_mutex;

#define disp_lock() rtems_semaphore_obtain(disp_mutex,RTEMS_WAIT,RTEMS_NO_TIMEOUT)
#define disp_unlock() rtems_semaphore_release(disp_mutex)
