	opt	noidw
	opt	so,xr
	page 	132,66,3,3


CACHE		equ	1


TOP_OF_MEMORY	equ	$7fff00

;	This section should be loaded at P:0 that way reset will
; 	cause a jump to main.

;	The reset section is located at p:0 in the mapfile. This section is
;	intended to hold system reset code. This code should jump to start
;	when it is done.

	section interrupts

	org	p:$0
	bra	>F__start

	endsec
	
	section	crt0

	org 	x:

; #########################################################################
; The following varaibles are used for dynamic memory allocation

; __stack_safty: Since dynamic memory and the stack grow towards each other 
; This constant tells brk and sbrk what the minimum amount of space should
; be left between the top of stack during the brk or sbrk call and the end
; of any allocated memory.

	global F__stack_safety
F__stack_safety	dc	1024

; __mem_limit: a constant telling brk and sbrk where the end of available 
;	memory is.

	global F__mem_limit
F__mem_limit	dc	TOP_OF_MEMORY


; __break: pointer to the next block of memory that can be allocated
;	The heap may be moved by changing the initial value of __break.
;	This is the base of the heap.

	global F__break
F__break	dc	TOP_OF_MEMORY

; __y_size: the base of dynamic memory.

	global F__y_size
F__y_size	dc	DSIZE

; errno: error type: set by some libraries

	global	Ferrno
Ferrno		dc	$0

; __max_signal the highest possible signal vector offset that might
;	be generated by the cpu.

	global	F__max_signal
F__max_signal	dc	$fe


; #########################################################################

	org	p:

	global	F__start
F__start

;	To change the base of the stack, change the value loaded into the
;	stack pointer here.

 if @def(CACHE)
	bset    #19,SR
 endif
	move	x:F__y_size,r6		; initialize the stack pointer
        
        bsr     F__init_c_vars            

	bsr	Fmain		; run user program

	bsr	Fexit		; when exit ( ) isn't explicitly called,
				; call it.
	debug

	global	F__crt0_end
F__crt0_end
	stop			; all done

	endsec

	section	time_counter

	org	x:
	global	F__time
F__time
	dc	0

	endsec

	section	io_primitives

	org	p:
 if 0
	global	F__send
F__send
	move	r2,x:(r6)
	move	a,r2
	do	b,_sendloop
	  brclr #1,x:<<$ffffc3,*
	  movep	x:(r2)+,x:<<$ffffc7
	  nop
	  nop
_sendloop:
	move	x:(r6),r2
 endif
	rts

	global	F__receive
F__receive
	move	a,r2
	move	x0,x:(r6)
	nop
	move	x:(r2+2),x0
	move	x0,x:(r2)
	move	x:(r6),x0
	rts

	endsec


; The following section, dummy_call, is used for doing command-line
; function calls on the ADS and simulator.  If you aren't going to use
; those features, it can be removed.

; The host software sets up the dummy call and patches the following
; object code to do the call and to clean things up after the call.
; If the function that the user is calling from the command line
; returns a structure or union, the value of r6 is moved into r7, and
; then r6 is incremented by the size of the structure or union being
; returned.  This negative of this size is then patched into the
; second ``move #N,n6'' instruction, so that we can clean up after the
; function call.  If no structure is returned, 0 is patched in for N
; in that move.  Following this, the current PC is moved into x:(r6)
; and then r6 is incremented.  The arguments to the function are then
; placed into registers A and B, with the remaineders placed on the
; stack starting at r6 (with r6 being incremented accordingly).
; The size of the arguments plus one (for the storage of the current
; PC) will needed to be cleaned off the stack after the function call,
; so we negate that value and patch it into the first ``move #N,n6''
; instruction.  The address of the target function is then patched
; into the jsr instruction.
;
; Following this the device is started and a ``finish'' (essentially)
; is done on dummy_call (which will then call the target function).
; If the function call is interrupted by the host software, the
; ADS/simulator is left in a state where the user can step out of the
; called function (because of the prologue code which is after the jsr
; in dummy_call).
;
; The prologue code decrements r6 by the amount used by the arguments
; to the target function plus one (to move us back to where the return
; address was stored).  Then x:(r6) is moved into ssh.  Then a (the
; return value) is tested, and r6 is decremented by the size of the
; structure returned from the target function (possibly 0 if no
; structure was returned).  Finally, we return to our caller.

	section dummy_call

	org	p:

	global	dummy_call
dummy_call
	jsr	>dummy_call
	move	#-1,n6
	move	(r6)+n6
	move	#-1,n6
	move	x:(r6),ssh
	tst	a	(r6)+n6
	rts

	endsec

        section init_table
        org p:
        xdef    F__begin_init_table
F__begin_init_table
        dc (-1)

        endsec

        section cinit
        org     p:
        xref  F__begin_init_table
        global  F__init_c_vars
F__init_c_vars   
	clr   a                     
	clr   b
        move  #$ffffff,m0
        move  m0,m1
        move  m0,m2
	move  #F__begin_init_table,r0

        do    forever,_lab1
; p:(r0)      destination start          
; p:(r0+1)    source start               
; p:(r0+2)    size of source block size  
; p:(r0+3)    size zero initialized block

        movem p:(r0)+,r1            ; destination start
        lua   (r1)+,b
        tst   b
        nop
        brkeq
        movem p:(r0)+,r2        ; source start           
        movem p:(r0)+,r3        ; size of expicitly initialized block
        movem p:(r0)+,r4        ; size of zero initialized block

        do    r3,_lab2
        movem p:(r2)+,x0
        move  x0,x:(r1)+
        nop
_lab2           
     
        do    r4,_lab3
        move  a1,x:(r1)+
_lab3   
        nop
_lab1
        rts                     

        endsec


; ###################################################################
; Reserve memory space that is not available for code or data        
; ###################################################################

; P-memory reserved areas

   section bootstrap_rom_p
   org   p:$ff0000
   ds    $c0         		; reserve 192 words occupied by bootstrap ROM
   endsec

   section no_mem_p
 if @def(CACHE)
   org   p:$000C00
 else
   org   p:$001000
 endif
   ds    ($7E0000-*)     	; reserve space where there is no P memory
   org	 p:$800000
   ds	 ($FFFFFF-*+1)
   endsec

   section no_mem_x
   org   x:$000800
   ds    ($400000-*)     	; reserve space where there is no X memory
   org	 x:$7E0000
   ds	 ($FFF000-*)
   endsec

   section io_x
   org	 x:$FFF000
   ds	 ($FFFFFF-*+1)
   endsec

   section no_mem_y
   org   y:$000800
   ds    ($400000-*)     	; reserve space where there is no Y memory
   org	 y:$7E0000
   ds	 ($FFF000-*)
   endsec

   section io_y
   org	 y:$FFF000
   ds	 ($FFFFFF-*+1)
   endsec
