/*******************************************************************************
 * C H A M E L E O N   DSP C file                                              *
 *******************************************************************************
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#ifndef __GLOBAL_H__
#define __GLOBAL_H__

#include <math.h>

/****************************************************************************/
#define PI			3.14159265358979
/****************************************************************************/
#define SAMPLERATE		48000
#define BLOCKSIZE		16
#define BLOCKMASK		(BLOCKSIZE-1)
#define HOST_BUFFER_SIZE	128
/****************************************************************************/
#define disable_interrupts() __asm("ori   #$03,mr")
#define enable_interrupts()  __asm("andi  #$FC,mr")
/****************************************************************************/
typedef void CChangeParameter(int *);
/****************************************************************************/

#define FRACT_SCALER		8388608.0

#define _FRACT(x) \
	(\
		((x) >= 0.0) ? \
		(\
			(((x)*FRACT_SCALER + 0.5) > FRACT_SCALER) ? 0x7FFFFF : (int) ((x)*FRACT_SCALER + 0.5)\
		) : (\
			(((x)*FRACT_SCALER - 0.5) < -FRACT_SCALER) ? 0x800000 : (int) ((x)*FRACT_SCALER - 0.5)\
		)\
	)

#define _FLOAT(x) (((x) & 0x800000) ? (float) (((x) & 0x7FFFFF)/FRACT_SCALER) - 1.0 : (float) (x)/FRACT_SCALER)

static __inline int mpy(int a, int b)
{
	int result;
	__asm volatile ("mpy %1,%2,%0" : "=D"(result) : "S"(a), "S"(b));
	return result;
}

#endif
