/*******************************************************************************
 * C H A M E L E O N   DSP C file                                              *
 *******************************************************************************
 * Copyright (C) 2001-2002 Soundart                                            *
 * www.soundart-hot.com                                                        *
 * support@soundart-hot.com                                                    *
 ******************************************************************************/

#include <stdio.h>
#include <chameleon.h>
#include "global.h"
#include "dma.h"

#include "../looper.h"

/****************************************************************************/
#define VOLUME_SMOOTH_FACTOR		0.99
#define FILTER_SMOOTH_FACTOR		0.98
/****************************************************************************/



#define MAXMEMSIZE (83000*48)
#define MEMSIZESTEP (4800)

#define INTERNAL_SHIFT 4	/* 4 bits to enable 9 signal additions per voice without any clipping */
				/* 3 bits wouldn't be enough because of the ninth addition */

/* DEBUG ! UNDEFINE TO REMOVE FEATURE */
#define USE_SMOOTH


#define TC_A_f .1
#define TC_R_f .9999

#define LIMITER_ATTACK_MS 200
#define LIMITER_RELEASE_MS 200


int nUsageNew;


#define GET_USAGE(__target) do { nUsageNew = GetUsageBufferDMA(BLOCKSIZE, bufferDAC, bufferADC); if (nUsageNew > __target) __target = nUsageNew; } while(0)

int usage_start=0,usage_thru=0,usage_lpr=0,usage_audio=0;
int nUsage = 0;

int looper_sync_flag=1;

/*
fonctionnement d'un looper :
	- attributs :
		- state : rien=0, play once=16, loop=48, record=64
			bit play=16
			bit loop=32
			bit record=64
		- *sample_buf
		- sample_offset
		- sample_buf_size
		- old_smp_ofs : en case de retrig, stocke smp_ofs au moment du retrig pour le Xfade

	- 3 modes possibles
		* rien
		* play
			2 dclinaisons : loop/once
		* record

	* mode rien :
		trivial

	* mode play&loop :
		pour chaque sample de .audio_out_[LR],
			audio_out[right][index]=mpy(sample_buf[sample_offset],OVol);
		si dernier_sample && loop :
			sample_offset=0;
		sinon :
			state = rien;
			send_to_CF(stop_[LR][1234]);

	* mode record :
		pour chaque sample de .audio_in_[LR],
			buf[ofs]=mpy(audio_in[right][index],IVol)
			++ofs
		si dernier_sample,
			state=rien;
			send_to_CF(stop_[LR][1234]);
*/


/*

fonctionnement du limiteur :

#define GRAIN 16	// nombre de bits de poids faible  ignorer pour indexer dans la table

#define GRAIN_MASQUE ((1<<GRAIN)-1)

#define TABLE_SIZE (1<<(24-GRAIN))

table_limiter[TABLE_SIZE];		// ].25;1[ -> ]0;1] volume  appliquer pour limiter le signal
table_limiter_delta[TABLE_SIZE];	// T[i+1]-T[i], T=table_limiter

get_volLR();

for vol={volL,volR} :
	if vol>.25 :
		multiply_signal{L,R} (vol);


multiply_signal(volume) :
	vol=volume-.25;
	i=vol>>GRAIN;
	ofs=(vol&GRAIN_MASQUE)<<(24-GRAIN);
	signal*=table_limiter[vol>>GRAIN]+()*table_limiter_delta[vol>>GRAIN]

*/

#define GRAIN 16

#define GRAIN_MASK ((1<<GRAIN)-1)

#define TABLE_SIZE 123

/*
-1dB=721482
-2dB=65AC8C
-3dB=5A9DF7
-6dB=4026E7
*/

#define THRESHOLD 0x65AC9	/* -1dB, shifted by 4 bits (721482h) */

/* the limiter table stores 1/(V-.25) when V > .25 */

signed int table_limiter[TABLE_SIZE+1] = {
0x7FFFFF, 0x6E9893, 0x615BBA, 0x56F368, 0x4E8DB3, 0x47A2A4, 0x41D64A, 0x3CE83B,
0x38AA04, 0x34F948, 0x31BC15, 0x2EDE71, 0x2C50BD, 0x2A0696, 0x27F608, 0x2616FA,
0x2462C8, 0x22D3F1, 0x2165DA, 0x2014A4, 0x1EDD05, 0x1DBC2F, 0x1CAFB8, 0x1BB58C,
0x1ACBDC, 0x19F113, 0x1923D1, 0x1862DD, 0x17AD25, 0x1701B5, 0x165FB3, 0x15C65E,
0x153508, 0x14AB14, 0x1427F7, 0x13AB31, 0x13344F, 0x12C2E9, 0x1256A0, 0x11EF1E,
0x118C13, 0x112D37, 0x10D247, 0x107B06, 0x10273D, 0x0FD6B7, 0x0F8945, 0x0F3EB9,
0x0EF6EC, 0x0EB1B7, 0x0E6EF7, 0x0E2E8B, 0x0DF054, 0x0DB435, 0x0D7A15, 0x0D41DA,
0x0D0B6C, 0x0CD6B6, 0x0CA3A4, 0x0C7221, 0x0C421D, 0x0C1386, 0x0BE64C, 0x0BBA5F,
0x0B8FB2, 0x0B6638, 0x0B3DE3, 0x0B16A7, 0x0AF07A, 0x0ACB50, 0x0AA71F, 0x0A83DE,
0x0A6183, 0x0A4006, 0x0A1F5E, 0x09FF84, 0x09E06F, 0x09C21A, 0x09A47D, 0x098791,
0x096B51, 0x094FB6, 0x0934BC, 0x091A5C, 0x090091, 0x08E757, 0x08CEA9, 0x08B682,
0x089EDF, 0x0887BA, 0x087110, 0x085ADD, 0x08451E, 0x082FCF, 0x081AED, 0x080674,
0x07F262, 0x07DEB3, 0x07CB64, 0x07B874, 0x07A5DE, 0x0793A1, 0x0781BB, 0x077028,
0x075EE7, 0x074DF5, 0x073D50, 0x072CF7, 0x071CE6, 0x070D1D, 0x06FD9A, 0x06EE5A,
0x06DF5C, 0x06D09E, 0x06C21F, 0x06B3DE, 0x06A5D8, 0x06980C, 0x068A79, 0x067D1D,
0x066FF8, 0x066307, 0x06564A
};
/*#error "FIXME : FadeOutTable doit avoir une taille de 24*BLOCKSIZE ( 8 * (3*BLOCKSIZE) )"*/


#if (BLOCKSIZE!=16)
#error "BLOCKSIZE not 16, don't wanna compile"
#endif

#define FADETBLSIZE (8*48)

signed int FadeOutTable[FADETBLSIZE]= {
0x7FFFFF, 0x7FFF1D, 0x7FFC76, 0x7FF810, 0x7FF1ED, 0x7FEA11, 0x7FE07F, 0x7FD53C,
0x7FC84A, 0x7FB9AD, 0x7FA969, 0x7F9781, 0x7F83F8, 0x7F6ED2, 0x7F5812, 0x7F3FBC,
0x7F25D3, 0x7F0A5B, 0x7EED57, 0x7ECECA, 0x7EAEB9, 0x7E8D25, 0x7E6A12, 0x7E4585,
0x7E1F80, 0x7DF806, 0x7DCF1B, 0x7DA4C3, 0x7D7900, 0x7D4BD5, 0x7D1D47, 0x7CED58,
0x7CBC0C, 0x7C8966, 0x7C5569, 0x7C2019, 0x7BE978, 0x7BB18A, 0x7B7852, 0x7B3DD3,
0x7B0211, 0x7AC50F, 0x7A86CF, 0x7A4756, 0x7A06A6, 0x79C4C2, 0x7981AD, 0x793D6C,
0x78F800, 0x78B16D, 0x7869B6, 0x7820DE, 0x77D6E8, 0x778BD8, 0x773FAF, 0x76F272,
0x76A424, 0x7654C7, 0x76045F, 0x75B2EE, 0x756078, 0x750CFF, 0x74B887, 0x746312,
0x740CA4, 0x73B540, 0x735CE7, 0x73039E, 0x72A968, 0x724E47, 0x71F23D, 0x719550,
0x713780, 0x70D8D0, 0x707946, 0x7018E1, 0x6FB7A5, 0x6F5597, 0x6EF2B7, 0x6E8F0A,
0x6E2A91, 0x6DC550, 0x6D5F4A, 0x6CF881, 0x6C90F8, 0x6C28B1, 0x6BBFB1, 0x6B55F9,
0x6AEB8C, 0x6A806E, 0x6A149F, 0x69A824, 0x693B00, 0x68CD34, 0x685EC3, 0x67EFB1,
0x678000, 0x670FB2, 0x669ECB, 0x662D4C, 0x65BB38, 0x654894, 0x64D55F, 0x64619E,
0x63ED54, 0x637881, 0x63032A, 0x628D51, 0x6216F8, 0x61A021, 0x6128D1, 0x60B108,
0x6038CA, 0x5FC019, 0x5F46F7, 0x5ECD67, 0x5E536D, 0x5DD909, 0x5D5E3E, 0x5CE310,
0x5C6780, 0x5BEB90, 0x5B6F45, 0x5AF29F, 0x5A75A1, 0x59F84E, 0x597AA7, 0x58FCB0,
0x587E6B, 0x57FFDA, 0x5780FF, 0x5701DE, 0x568278, 0x5602CF, 0x5582E5, 0x5502BF,
0x54825D, 0x5401C1, 0x5380EF, 0x52FFE8, 0x527EAF, 0x51FD46, 0x517BAE, 0x50F9EB,
0x507800, 0x4FF5EC, 0x4F73B4, 0x4EF15A, 0x4E6EDE, 0x4DEC44, 0x4D698F, 0x4CE6BF,
0x4C63D8, 0x4BE0DB, 0x4B5DCA, 0x4ADAA8, 0x4A5778, 0x49D439, 0x4950F0, 0x48CD9E,
0x484A45, 0x47C6E7, 0x474387, 0x46C026, 0x463CC6, 0x45B96B, 0x453614, 0x44B2C5,
0x442F80, 0x43AC46, 0x432919, 0x42A5FD, 0x4222F1, 0x419FF9, 0x411D17, 0x409A4C,
0x40179A, 0x3F9504, 0x3F128B, 0x3E9030, 0x3E0DF8, 0x3D8BE1, 0x3D09EF, 0x3C8825,
0x3C0683, 0x3B850A, 0x3B03BF, 0x3A82A1, 0x3A01B3, 0x3980F8, 0x39006F, 0x38801B,
0x380000, 0x37801C, 0x370074, 0x368107, 0x3601D9, 0x3582EB, 0x35043F, 0x3485D6,
0x3407B2, 0x3389D5, 0x330C40, 0x328EF6, 0x3211F7, 0x319546, 0x3118E5, 0x309CD4,
0x302116, 0x2FA5AB, 0x2F2A97, 0x2EAFDA, 0x2E3576, 0x2DBB6C, 0x2D41BF, 0x2CC870,
0x2C4F7F, 0x2BD6F0, 0x2B5EC3, 0x2AE6FA, 0x2A6F97, 0x29F89B, 0x298207, 0x290BDD,
0x28961F, 0x2820CE, 0x27ABEB, 0x273779, 0x26C377, 0x264FE9, 0x25DCCF, 0x256A2B,
0x24F7FE, 0x248649, 0x24150F, 0x23A450, 0x23340E, 0x22C449, 0x225505, 0x21E641,
0x2177FF, 0x210A41, 0x209D08, 0x203055, 0x1FC42A, 0x1F5887, 0x1EED6F, 0x1E82E2,
0x1E18E1, 0x1DAF6F, 0x1D468C, 0x1CDE39, 0x1C7677, 0x1C0F49, 0x1BA8AF, 0x1B42AA,
0x1ADD3B, 0x1A7865, 0x1A1427, 0x19B083, 0x194D7B, 0x18EB0E, 0x188940, 0x182810,
0x17C77F, 0x176790, 0x170843, 0x16A998, 0x164B92, 0x15EE31, 0x159177, 0x153564,
0x14D9F9, 0x147F38, 0x142521, 0x13CBB6, 0x1372F7, 0x131AE6, 0x12C384, 0x126CD1,
0x1216CE, 0x11C17E, 0x116CDF, 0x1118F4, 0x10C5BD, 0x10733B, 0x102170, 0x0FD05C,
0x0F7FFF, 0x0F305C, 0x0EE172, 0x0E9343, 0x0E45D0, 0x0DF919, 0x0DAD1F, 0x0D61E3,
0x0D1766, 0x0CCDA9, 0x0C84AC, 0x0C3C71, 0x0BF4F7, 0x0BAE41, 0x0B684E, 0x0B2320,
0x0ADEB7, 0x0A9B13, 0x0A5837, 0x0A1622, 0x09D4D5, 0x099450, 0x095496, 0x0915A5,
0x08D77F, 0x089A25, 0x085D97, 0x0821D6, 0x07E6E3, 0x07ACBD, 0x077367, 0x073AE0,
0x070328, 0x06CC42, 0x06962C, 0x0660E9, 0x062C77, 0x05F8D9, 0x05C60E, 0x059417,
0x0562F4, 0x0532A7, 0x05032F, 0x04D48D, 0x04A6C2, 0x0479CD, 0x044DB1, 0x04226C,
0x03F7FF, 0x03CE6C, 0x03A5B2, 0x037DD1, 0x0356CB, 0x0330A0, 0x030B4F, 0x02E6DA,
0x02C340, 0x02A083, 0x027EA2, 0x025D9E, 0x023D77, 0x021E2E, 0x01FFC3, 0x01E236,
0x01C587, 0x01A9B8, 0x018EC7, 0x0174B6, 0x015B84, 0x014332, 0x012BC1, 0x011530,
0x00FF7F, 0x00EAB0, 0x00D6C2, 0x00C3B4, 0x00B189, 0x00A03F, 0x008FD7, 0x008051,
0x0071AD, 0x0063EC, 0x00570D, 0x004B11, 0x003FF7, 0x0035C1, 0x002C6D, 0x0023FD,
0x001C70, 0x0015C6, 0x000FFF, 0x000B1C, 0x00071C, 0x0003FF, 0x0001C7, 0x000071
/* old 48-word table
0x7FFFFF, 0x7FC84A, 0x7F25D3, 0x7E1F80, 0x7CBC0C, 0x7B0211, 0x78F800, 0x76A424,
0x740CA4, 0x713780, 0x6E2A91, 0x6AEB8C, 0x678000, 0x63ED54, 0x6038CA, 0x5C6780,
0x587E6B, 0x54825D, 0x507800, 0x4C63D8, 0x484A45, 0x442F80, 0x40179A, 0x3C0683,
0x380000, 0x3407B2, 0x302116, 0x2C4F7F, 0x28961F, 0x24F7FE, 0x2177FF, 0x1E18E1,
0x1ADD3B, 0x17C77F, 0x14D9F9, 0x1216CE, 0x0F7FFF, 0x0D1766, 0x0ADEB7, 0x08D77F,
0x070328, 0x0562F4, 0x03F7FF, 0x02C340, 0x01C587, 0x00FF7F, 0x0071AD, 0x001C70*/
};

#define FADEOUT 1
#define FADEIN 2


typedef struct {
	signed int val;
	signed int target;
} Volume_Smoother_t;



typedef struct {
	signed int yn1,clip;
} Env_Follower_t;



typedef struct {
	unsigned int id;	/* stores looper identifier for messages (l/r + looper#) */
	unsigned int state;
	unsigned int pending_state;
	signed int* smpbuf;
	unsigned int smp_ofs;
	unsigned int smpbuf_sz;
	unsigned int loop_ofs;
	unsigned int fadein;
	unsigned int fadeout;
	unsigned int fade;	/* flag */
	unsigned int fadeoutofs;
	Volume_Smoother_t OVol;
#error "FIXME : il faut revoir la struct Looper_t pour inclure fade-in fade-out proprement et virer oso_block et old_smp_ofs"
} Looper_t;

#define LEFT 0
#define RIGHT 1

signed int SMOOTHVOL;
signed int smoothincr;
signed int SMOOTHVOL2;
signed int smoothincr2;

#ifdef USE_SMOOTH

	#define SMOOTH_INIT(_name) \
		SMOOTHVOL= _name.val;\
		smoothincr = mpy(_FRACT(1.0-VOLUME_SMOOTH_FACTOR), _name.target);\
		smoothincr -= mpy(_FRACT(1.0-VOLUME_SMOOTH_FACTOR), SMOOTHVOL)
	
	#define SMOOTH() SMOOTHVOL+=smoothincr
	
	#define SMOOTH_DONE(_name) _name.val=SMOOTHVOL
	
	
	#define SMOOTH_INIT2(_name) \
		SMOOTHVOL2= _name.val;\
		smoothincr2 = mpy(_FRACT(1.0-VOLUME_SMOOTH_FACTOR), _name.target);\
		smoothincr2 -= mpy(_FRACT(1.0-VOLUME_SMOOTH_FACTOR), SMOOTHVOL2)
	
	#define SMOOTH2() SMOOTHVOL2+=smoothincr2
	
	#define SMOOTH_DONE2(_name) _name.val=SMOOTHVOL2
	
	#define SMOOTH_SET(_name) \
		SMOOTHVOL= _name.val;\
		smoothincr = mpy(_FRACT((1.0-VOLUME_SMOOTH_FACTOR)*BLOCKSIZE), _name.target);\
		smoothincr -= mpy(_FRACT((1.0-VOLUME_SMOOTH_FACTOR)*BLOCKSIZE), SMOOTHVOL);\
		_name.val+=smoothincr
		
#else
	
	#define SMOOTH_INIT(_name) \
		SMOOTHVOL= _name.target;
	
	#define SMOOTH()
	
	#define SMOOTH_DONE(_name) _name.val=SMOOTHVOL
	
	
	#define SMOOTH_INIT2(_name) \
		SMOOTHVOL2= _name.target;
	
	#define SMOOTH2()
	
	#define SMOOTH_DONE2(_name) _name.val=SMOOTHVOL2
	
	#define SMOOTH_SET(_name)

#endif


Volume_Smoother_t IVolL,IVolR,ThruL,ThruR,OutVol,CompL,CompR;


#define LPADDR(n) (((signed int*)_membase)+(n*LOOPBUF_SZ))
#define LOOPER(lr,n) { (lr?MSG_BIT_RIGHT|n:n), 0, 0, 0, 0, 0, 0, 0, { 0,0 } }
Looper_t looper[2][4] = {
	{ LOOPER(0,0), LOOPER(0,1), LOOPER(0,2), LOOPER(0,3) },
	{ LOOPER(1,0), LOOPER(1,1), LOOPER(1,2), LOOPER(1,3) }
};


signed int*parameters[N_PARAMETERS+1]= { 
&IVolL.target,&IVolR.target,
&looper[0][0].OVol.target,&looper[0][1].OVol.target,
&looper[0][2].OVol.target,&looper[0][3].OVol.target,
&looper[1][0].OVol.target,&looper[1][1].OVol.target,
&looper[1][2].OVol.target,&looper[1][3].OVol.target,
&ThruL.target,&ThruR.target,
&OutVol.target };


#define LSZ_UNUSED	0
#define LSZ_NORMAL	0x10
#define LSZ_HALF	0x08
#define LSZ_DOUBLE	0x20
#define LSZ_TRIPLE	0x30
#define LSZ_QUADRUPLE	0x40

int loop_length_modes[N_MODES][4] = {
{LSZ_NORMAL,	LSZ_NORMAL,	LSZ_NORMAL,	LSZ_NORMAL},
{LSZ_DOUBLE,	LSZ_NORMAL,	LSZ_HALF,	LSZ_HALF},
{LSZ_DOUBLE,	LSZ_NORMAL,	LSZ_NORMAL,	LSZ_UNUSED},
{LSZ_DOUBLE,	LSZ_DOUBLE,	LSZ_UNUSED,	LSZ_UNUSED},
{LSZ_TRIPLE,	LSZ_HALF,	LSZ_HALF,	LSZ_UNUSED},
{LSZ_TRIPLE,	LSZ_NORMAL,	LSZ_UNUSED,	LSZ_UNUSED},
{LSZ_QUADRUPLE,	LSZ_UNUSED,	LSZ_UNUSED,	LSZ_UNUSED},
};

unsigned int looper_mode;


unsigned int LOOPBUF_SZ;

/*typedef unsigned int word;*/




signed int* volatile _membase=(signed int*)/*0x440000;*/NULL;
unsigned int volatile _memsize=(unsigned int)/*0x3C0000;*/0;



#define USAGE_BPF 1500	/* about 2 fps */

#define USAGE_MESSAGE (0xFE0000|(BLOCKSIZE<<9))
#define USAGE_DEBUG(n) (0xF00000|(n<<8))




#define EF_LOOPER 0
#define EF_IN 8
#define EF_OUT 10

#define SAMPLE_PER_VOLUME_MESSAGE 4800

#define _bsz(n) ((BLOCKSIZE*n)%SAMPLE_PER_VOLUME_MESSAGE)


Env_Follower_t env_follower[12] = {
	{0,0}, {0,0}, {0,0}, {0,0},
	{0,0}, {0,0}, {0,0}, {0,0},
	{0,0}, {0,0},
	{0,0}, {0,0},
};

int looper_recording=0;


#pragma x_run x:$400000
static int bufferHostTx[HOST_BUFFER_SIZE]; /* These buffers need to be aligned */
static int bufferHostRx[HOST_BUFFER_SIZE];
static int bufferDAC[2][2*BLOCKSIZE];
static int bufferADC[2][2*BLOCKSIZE];
#pragma x_run


#define TC_ATTACK _FRACT(TC_A_f)
#define TC_RELEASE _FRACT(TC_R_f)
#define _1_TC_ATTACK _FRACT(1.-TC_A_f)
#define _1_TC_RELEASE _FRACT(1.-TC_R_f)
/*
#define TC_ATTACK 0x400000
#define TC_RELEASE 0x7FFF00
#define _1_TC_ATTACK (0x7FFFFF-TC_ATTACK)
#define _1_TC_RELEASE (0x7FFFFF-TC_RELEASE)
*/

#define LIMITER_ATTACK_PER_SAMPLE _FRACT(15.f/16.f/LIMITER_ATTACK_MS/48.f)
#define LIMITER_RELEASE_PER_SAMPLE _FRACT(15.f/16.f/LIMITER_RELEASE_MS/48.f)


signed int limiter_L=0x7FFFFF,limiter_R=0x7FFFFF;

static __inline void limit_signal(signed int*signal,Env_Follower_t*volume,signed int*limiter) {
#if 1
	signed int ls_vol;
	signed int ls_delta;
	signed int ls_ofs;
	if(volume->yn1<=THRESHOLD) {						/* volume suffisamment bas => pas de limitation */
		ls_vol=0x7FFFFF;
	} else {								/* sinon, dterminer la valeur cible de la limitation */
		ls_vol=volume->yn1-THRESHOLD;
		ls_ofs=(ls_vol&GRAIN_MASK)<<(24-GRAIN);
		ls_vol>>=GRAIN;
		ls_delta=table_limiter[ls_vol+1]-table_limiter[ls_vol];
		ls_vol=table_limiter[ls_vol]+mpy(ls_ofs,ls_delta);
	}
	if(*limiter>ls_vol/*+LIMITER_ATTACK_PER_SAMPLE*/)			/* limiteur actuellement en-dessous (valeur plus grande gale limitation plus faible) de la valeur cible : attack */
		*limiter-=LIMITER_ATTACK_PER_SAMPLE;
	else if(*limiter<ls_vol/*-LIMITER_RELEASE_PER_SAMPLE*/)			/* limiteur actuellement en-dessus de la valeur cible : release */
		*limiter+=LIMITER_RELEASE_PER_SAMPLE;
	if(*limiter<table_limiter[TABLE_SIZE])
		*limiter=table_limiter[TABLE_SIZE];
	else if(*limiter&0x800000)
		*limiter=0x7FFFFF;
	*signal = mpy(*limiter,*signal);
#endif
}



static __inline void env_follow(int ef,signed int sample) {
	Env_Follower_t*E=&(env_follower[ef]);
	unsigned int smp=sample<0?-sample:sample;
	signed int tc,_1tc;

	if(smp>E->yn1) {
		tc=TC_ATTACK;
		_1tc=_1_TC_ATTACK;
	} else {
		tc=TC_RELEASE;
		_1tc=_1_TC_RELEASE;
	}

	E->yn1=mpy(_1tc,smp)+mpy(tc,E->yn1);

/*	if(smp>E->yn1) {
		E->yn1=smp;
	} else {
		tc=TC_RELEASE;
		_1tc=_1_TC_RELEASE;
		E->yn1=mpy(_1tc,smp)+mpy(tc,E->yn1);	
	}*/

	if(smp>=(0x7FFFFF>>INTERNAL_SHIFT)) ++E->clip;
}


static __inline void send_envs() {
	static int count=-1;
	int ef;
	unsigned int msg;
	count+=BLOCKSIZE;
	if(count>=SAMPLE_PER_VOLUME_MESSAGE) {
		for(ef=0;ef<12;ef++) {
			if(env_follower[ef].clip)
				msg=MkMessage(MSG_BIT_SET|ef,0x7FFF);
			else
				msg=MkMessage(MSG_BIT_SET|ef,env_follower[ef].yn1>>(8-INTERNAL_SHIFT));/* takes into account the input shift */
			env_follower[ef].clip=0;
			WriteHostData(1,&msg);
		}
		count=0;
/*		msg=USAGE_DEBUG(4)|((limiter_L>>16)&0xFF);
		WriteHostData(1, &msg);
		msg=USAGE_DEBUG(5)|((limiter_R>>16)&0xFF);
		WriteHostData(1, &msg);*/
	}
}



/*static __inline void erase_loop_click(Looper_t*l) {
	signed int *I,*O,z;
	if(l->loop_ofs<6*BLOCKSIZE)
		return;
	I=l->smpbuf;
	O=l->smpbuf+l->loop_ofs-BLOCKSIZE;
	for(z=0;z<3*BLOCKSIZE;z++) {
		*I=mpy(FadeOutTable[3*BLOCKSIZE-z],*I);
		*O=mpy(FadeOutTable[z],*O);
		++I;
		++O;
	}
}
*/



static __inline void stop_looper(Looper_t*l) {
	int a;
	/*TRACE("0x%X STOP\n",l->id);*/
	l->old_smp_ofs=0;
	l->oso_block=0;
	l->state=0;
	a=0x7F00|l->id;
	WriteHostData(1,&a);
	if(l->id&MSG_BIT_RIGHT) {
		a=MkMessage((MSG_BIT_SET|4|(l->id&3)),0);
	} else {
		a=MkMessage((MSG_BIT_SET|(l->id&3)),0);
	}
	WriteHostData(1,&a);
}







static __inline void looper_set_state(int lr, int num, int state) {
	Looper_t*l=&(looper[lr][num]);
	if(looper_sync_flag) {
		l->pending_state=0;
		if(l->state&STATE_BIT_REC) {
			l->loop_ofs=l->smp_ofs;
			erase_loop_click(l);
		}
		if(l->state&state&STATE_BIT_PLAY)	/* if was playing, and is retrigged, then remember old smp_ofs to perform Xfade */
			l->old_smp_ofs=l->smp_ofs;
			l->oso_block=3;
		if((!(state&STATE_BIT_PLAY))||l->loop_ofs) {
			l->smp_ofs=0;
			l->state=state;
		} else {
			l->old_smp_ofs=l->smp_ofs;
			if(l->smp_ofs<l->loop_ofs-3*BLOCKSIZE)
				l->oso_block=3;
			else
				l->oso_block=(l->loop_ofs-l->smp_ofs)>>4;
#if BLOCKSIZE!=16
	#error "expecting BLOCKSIZE=16"
#endif
			stop_looper(l);
		}
	} else {
		l->pending_state=state;
	}
}





/* Fade config parameters */
int fade_step;
/* Fade internals */
int fade_block_step=8;	/* legal values 1 2 4 8 */


static __inline void init_fadeout(Looper_t*l) {		/* starts a fade-in at current smp_ofs */
	l->fadeoutofs=l->smp_ofs;
	l->fadeout=0;
	l->fade|=FADEOUT;
}


static __inline void init_fadein(Looper_t*l) {		/* starts a fade-out at current smp_ofs */
	l->fadein=FADETBLSIZE-1;
	l->fade|=FADEIN;
}


static __inline int fade(int fade_offset,int sample) {	/* calculate faded sample value */
	return mpy(FadeOutTable[fade_offset],sample);
}


static __inline void incr_fadeout(Looper_t*l) {		/* increment fade offset */
	l->fadeout+=fade_step;
	if(l->fadeout>=FADETBLSIZE) l->fade&=~FADEOUT;
}


static __inline void incr_fadein(Looper_t*l) {		/* decrement fade offset */
	l->fadein-=fade_step;
	if(l->fadein&0x800000) l->fade&=~FADEIN;
}


static __inline int fadein(Looper_t*l) {
	return l->fadein!=0;
}


static __inline int fadeout(Looper_t*l) {
	return l->fadeout_ofs!=0;
}


/*static __inline*/ void do_looper(signed int*in,signed int*out,Looper_t*l,Volume_Smoother_t*IVol) {
	int i;
	signed int smp,s,*L,*O;	/* sample value, temp var, looper buf@ofs, looper buf@old ofs */
	int n,k;
	
	if(!(l->id&MSG_BIT_RIGHT)) {
		++in;
		++out;
	}
	/* FIXME : rcrire play pour tenir compte de fadein/fadeout */
	n=l->id&MSG_BIT_RIGHT?(4+(l->id&3)):l->id;
	if(l->state&STATE_BIT_PLAY) {

		/*  faire : switch(l->fade) {
				case 0 : lecture normale
				case 1 : fadeout (ne devrait apparatre qu'aprs arrt d'une lecture sans retrig
				case 2 : fadein
				case 3 : fadein + fadeout
				};
		*/

		SMOOTH_INIT(l->OVol);
		L=l->smpbuf+l->smp_ofs;
		if(l->oso_block) {
			O=l->smpbuf+l->old_smp_ofs;
			k=l->oso_block==3?2*BLOCKSIZE:l->oso_block==2?BLOCKSIZE:0;
			for(i=0;i<BLOCKSIZE;++i) {
				smp=mpy(SMOOTHVOL,*L)+mpy(FadeOutTable[k+i],*O);
				++L;
				++O;
				*out+=smp; ++out; ++out;
				env_follow(n,smp);
				SMOOTH();
			}
			--l->oso_block;
			if(!l->oso_block) l->old_smp_ofs=0;
			else l->old_smp_ofs+=BLOCKSIZE;
		} else {
			for(i=0;i<BLOCKSIZE;++i) {
				smp=mpy(SMOOTHVOL,*L);
				++L;
				*out+=smp; ++out; ++out;
				env_follow(n,smp);
				SMOOTH();
			}
		}
		l->smp_ofs+=BLOCKSIZE;
		SMOOTH_DONE(l->OVol);

		if(l->smp_ofs==l->loop_ofs) {
			if(l->state&STATE_BIT_LOOP)
				l->smp_ofs=0;
			else
				stop_looper(l);
		}
	} else if(l->state&STATE_BIT_REC) {
		looper_recording=1;
		SMOOTH_INIT((*IVol));
		L=l->smpbuf+l->smp_ofs;
		for(i=0;i<BLOCKSIZE;++i) {
			*L=mpy(SMOOTHVOL,*in);
			++in;
			++in;
			env_follow(n,*L);
			++L;
			SMOOTH();
		}
		l->smp_ofs+=BLOCKSIZE;
		if(l->smp_ofs==l->smpbuf_sz) {
			l->loop_ofs=l->smpbuf_sz;
			erase_loop_click(l);
			stop_looper(l);
		}
	} else if(l->oso_block) {
		O=l->smpbuf+l->old_smp_ofs;
		SMOOTH_INIT(l->OVol);
		k=l->oso_block==3?2*BLOCKSIZE:l->oso_block==2?BLOCKSIZE:0;
		for(i=0;i<BLOCKSIZE;++i) {
			smp=mpy(FadeOutTable[i],*O);
			++O;
			*out+=smp; ++out; ++out;
			env_follow(n,smp);
			SMOOTH();
		}
		SMOOTH_DONE(l->OVol);
		--l->oso_block;
		if(!l->oso_block) l->old_smp_ofs=0;
		else l->old_smp_ofs+=BLOCKSIZE;
	}
}


static __inline void unshift_output(signed int*out) {
	int i;
	for(i=0;i<BLOCKSIZE;++i) {
		/* try out some quick easy version : since the shift is enough for 16 additions, assume there will be NO out-of-range sample */
		env_follow(EF_OUT+1,*out);
		limit_signal(out,&(env_follower[EF_OUT+1]),&limiter_R);
		if(*out>0x7FFFF) *out=0x7FFFFF;
		else if(*out<(-0x7FFFFF)) *out=0x800000;
		else *out<<=INTERNAL_SHIFT;
		++out;
		env_follow(EF_OUT,*out);
		limit_signal(out,&(env_follower[EF_OUT]),&limiter_L);
		if(*out>0x7FFFF) *out=0x7FFFFF;
		else if(*out<(-0x7FFFFF)) *out=0x800000;
		else *out<<=INTERNAL_SHIFT;
		++out;
	}
}




static __inline void do_thru(signed int*in,signed int*out) {
	int i;
	SMOOTH_INIT(ThruR);
	SMOOTH_INIT2(ThruL);
	for(i=0;i<BLOCKSIZE;++i) {
		*in>>=INTERNAL_SHIFT;
		env_follow(EF_IN+1,*in);
		*out=mpy(SMOOTHVOL,*in);
		++in;
		++out;
		*in>>=INTERNAL_SHIFT;
		env_follow(EF_IN,*in);
		*out=mpy(SMOOTHVOL2,*in);
		SMOOTH();
		SMOOTH2();
		++in;
		++out;
	}
	SMOOTH_DONE(ThruR);
	SMOOTH_DONE2(ThruL);
}



static __inline void do_audio() {
	int *out = GetActiveBufferDAC(),*o;
	int *in = GetActiveBufferADC();
	int i;

	GET_USAGE(usage_start);

	do_thru(in,out);	/* do_thru takes care of buffer cleaning */

	GET_USAGE(usage_thru);

	looper_recording=0;
	do_looper(in,out,&(looper[0][0]),&IVolL);
	do_looper(in,out,&(looper[0][1]),&IVolL);
	do_looper(in,out,&(looper[0][2]),&IVolL);
	do_looper(in,out,&(looper[0][3]),&IVolL);
	if(looper_recording) {
		SMOOTH_DONE(IVolL);
		looper_recording=0;
	}
	do_looper(in,out,&(looper[1][0]),&IVolR);
	do_looper(in,out,&(looper[1][1]),&IVolR);
	do_looper(in,out,&(looper[1][2]),&IVolR);
	do_looper(in,out,&(looper[1][3]),&IVolR);
	if(looper_recording) {
		SMOOTH_DONE(IVolR);
	}


	GET_USAGE(usage_lpr);

	SMOOTH_INIT(OutVol);

	o=out;
	
	for(i=0;i<BLOCKSIZE;++i) {
		*o=mpy(SMOOTHVOL,*o);
		++o;
		*o=mpy(SMOOTHVOL,*o);
		++o;
		SMOOTH();
	}
	SMOOTH_SET(OutVol);

	unshift_output(out);

	GET_USAGE(usage_audio);
}




void set_looper_buf(Looper_t*l,signed int*start, unsigned int size) {
	l->state=0;
	l->smpbuf=start;
	l->smp_ofs=0;
	l->loop_ofs=0;
	l->smpbuf_sz=size;
}


unsigned int llm_sz(int m) {
	switch(m) {
		case LSZ_NORMAL: return LOOPBUF_SZ;
		case LSZ_HALF: return LOOPBUF_SZ>>1;
		case LSZ_DOUBLE: return LOOPBUF_SZ<<1;
		case LSZ_TRIPLE: return LOOPBUF_SZ*3;
		case LSZ_QUADRUPLE: return LOOPBUF_SZ<<2;
		case LSZ_UNUSED: return 0;
	};
	return 0;
}

void set_looper_buf_mode(int mode) {
	static int oldl=-1,oldr=-1;
	int i;
	signed int*ptr;
	int sz;
	int lmode=ModeL(mode)&7;
	int rmode=ModeR(mode)&7;
	if(lmode!=oldl) {
		/*TRACE(" Change buf mode L #%i => #%i\n",oldl,lmode);*/
		ptr=_membase;
		for(i=0;i<4;i++) {
			sz=llm_sz(loop_length_modes[lmode][i]);
			set_looper_buf(&(looper[0][i]),ptr,sz);
			ptr+=sz;
		}
		oldl=lmode;
	}
	if(rmode!=oldr) {
		/*TRACE(" Change buf mode R #%i => #%i\n",oldr,rmode);*/
		ptr=_membase+(_memsize>>1);
		for(i=0;i<4;i++) {
			sz=llm_sz(loop_length_modes[rmode][i]);
			set_looper_buf(&looper[1][i],ptr,sz);
			ptr+=sz;
		}
		oldr=rmode;
	}
	/*TRACE(" Looper Buf repartition mode #%i / #%i\n",oldl,oldr);*/
}


void checkHostData() {
/* FIXME : il faut grer les messages 'real-time' (modif tat looper) qui peuvent couper en deux un message SET */
	int toread=GetHostReceivedDataCount();
	static int lr,num;
	static unsigned int msg=0,value;
	unsigned int loopstart,looplen;
	if(!toread)
		return;
	for(;toread>0;) {
/*
 init :
	msg=0;
  chaque mot :
	- si RTMSG :
		- fait RTMSG
	- sinon :
		- si msg==0 :
			- lit msg ;
			- si msg&64 :
				- fait msg;
				- msg = 0;
				
		- sinon :
			- lit valeur ;
			- fait message ;
*/

/* FIXME : checker rtmsg  chaque mot */
		ReadHostData(1,&value);
		--toread;
		if(value&0xFFFF00==0xFFFF) {
			switch(value&0xFF) {
			case 0xFF : /* start sync window */
				looper_sync_flag=1;
				set_pending_looper_states();
				break;
			case 0xFE : /* end sync window */
				looper_sync_flag=0;
				break;
			default : /* looper state command */
				lr=msg&MSG_BIT_RIGHT?1:0;
				num=msg&MSG_MASK_LOOPER;
				looper_set_state(lr,num,msg&MSG_MASK_STATE);
				WriteHostData(1,&msg);	/* loopback */
				/*TRACE("[DSP] Set Looper[%i][%i] State to %X\n",lr,num,msg&MSG_MASK_STATE);*/
				break;
			};
			msg=0;
		} else if(!msg) {
				msg=value;
				if(msg&MSG_BIT_SET) {
					if(msg&64) {
						/*TRACE("msg %X\n",msg);*/
						num=msg&0xF;
						switch(num) {
						case 0:	/* 0x??40 : get loopmem size */
							WriteHostData(1,&msg);
							WriteHostData(1,&_memsize);
							WriteHostData(1,&_membase);
							break;
						case 1: /* 0x??41 : set looplengths mode */
							set_looper_buf_mode(Param(msg)&0x3F);
							WriteHostData(1,&msg);
							break;
						case 2: /* 0x??42 : set internal freq : 1=48000 0=32000 */
							break;
						default:;
						};
						msg=0;
					}
				}
			}
		} else {
			*(parameters[Param(msg)])=value;
			/*TRACE("Setting param #%i to value %f\n",Param(msg),_FLOAT(value));*/
			msg=0;
		}
	}
}

int checkHostDataInit() {
/* FIXME : il faut grer les messages 'real-time' (modif tat looper) qui peuvent couper en deux un message SET */
	int toread=GetHostReceivedDataCount();
	unsigned int msg=0;
	if(!toread)
		return;
	for(;toread>0;) {
		ReadHostData(1,&msg);
		--toread;
		if(!msg) {
			WriteHostData(1,&msg);
			return 1;
		}
	}
	return 0;
}


/* Display DSP usage */
static void showUsage(void)
{
	static int nBlockCounter = 0;

/*	nUsageNew = GetUsageBufferDMA(BLOCKSIZE, bufferDAC, bufferADC);
	if (nUsageNew > nUsage)
		nUsage = nUsageNew;*/
	GET_USAGE(nUsage);
	
	if (nBlockCounter >= USAGE_BPF) {
		nUsageNew = USAGE_MESSAGE|(0xFF&nUsage);
		WriteHostData(1, &nUsageNew);

/*		usage_start|=USAGE_DEBUG(0);
		usage_thru|=USAGE_DEBUG(1);
		usage_lpr|=USAGE_DEBUG(2);
		usage_audio|=USAGE_DEBUG(3);
		WriteHostData(1, &usage_start);
		WriteHostData(1, &usage_thru);
		WriteHostData(1, &usage_lpr);
		WriteHostData(1, &usage_audio);*/
		
		nUsage = 0;
		usage_start=0;
		usage_thru=0;
		usage_lpr=0;
		usage_audio=0;

		nBlockCounter = 0;
	}
	
	nBlockCounter++;
}


static void processEngine() {

	while (TRUE) {
		checkHostData();
		do_audio();
		send_envs();
		showUsage();
		ChangeActiveBufferDMA(BLOCKSIZE, bufferDAC, bufferADC);
	}
}



void main(void) {
	disable_interrupts();

	ConfigHostInterrupts(HOST_BUFFER_SIZE, bufferHostTx, bufferHostRx);

	ConfigAudioDMA(BLOCKSIZE, bufferDAC, bufferADC);

	enable_interrupts();
	
	/*TRACE("*\n* quelques debugs : 0x800000>>2=%X 0x200000<<2=%X\n*\n",((signed int)0x800000)>>2,((signed int)0x200000)<<2);*/

	/*init_mem();*/

/*	_membase=(signed int*)malloc(MAXMEMSIZE);
	if(_membase)
		_memsize=MAXMEMSIZE;*/

	while(!_memsize) {
		_membase=NULL;

		_memsize=MAXMEMSIZE;
		while(_memsize>MEMSIZESTEP&&!(_membase=(signed int*)malloc(_memsize))) {
			_memsize-=MEMSIZESTEP;
		};
		if(_memsize<=MEMSIZESTEP)
			_memsize=0;
	}

	LOOPBUF_SZ=(_memsize>>3)&(~(BLOCKSIZE-1)); /* be sure it's a multiple of BLOCKSIZE */

	while(!checkHostDataInit());
	TRACE("DSP Initialized OK!\n");

	if(LOOPBUF_SZ)
		processEngine();
}

