#include "ihm.h"
#include <string.h>

#define N_CHAMIE_BUTTONS 12


#define VOL_LOOPER 0
#define VOL_IN 8
#define VOL_OUT 10

char* preset_name_chars=" abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-_+/|\\.:;!?@#&%";

extern char*param_names[6];


float loop_length_modes[N_MODES][4] = {
{1.0f,	1.0f,	1.0f,	1.0f},
{2.0f,	1.0f,	0.5f,	0.5f},
{2.0f,	1.0f,	1.0f,	0.0f},
{2.0f,	2.0f,	0.0f,	0.0f},
{3.0f,	0.5f,	0.5f,	0.0f},
{3.0f,	1.0f,	0.0f,	0.0f},
{3.0f,	0.0f,	0.0f,	0.0f},
};

extern int dsp;

extern int looper_on[2][4];

extern rtems_unsigned32 db2coef[128];

rtems_unsigned32 chamie_buttons[N_CHAMIE_BUTTONS]= {
	PANEL01_KEY_EDIT,
	PANEL01_KEY_SHIFT,
	PANEL01_KEY_PART_UP,
	PANEL01_KEY_PART_DOWN,
	PANEL01_KEY_GROUP_UP,
	PANEL01_KEY_GROUP_DOWN,
	PANEL01_KEY_PAGE_UP,
	PANEL01_KEY_PAGE_DOWN,
	PANEL01_KEY_PARAM_UP,
	PANEL01_KEY_PARAM_DOWN,
	PANEL01_KEY_VALUE_UP,
	PANEL01_KEY_VALUE_DOWN
};



rtems_id user_input;

rtems_interval TMR_ticks_per_s;
rtems_interval TMR_last_msg10=0;
rtems_interval TMR_last_msg10_accum=0;
rtems_interval TMR_ticks_per_msg10;


int volatile panel;


rtems_unsigned32 Panel_Mode;



int i;
rtems_unsigned8	potentiometer;
rtems_signed8	value;
rtems_unsigned32 bits,bitsdiff;
rtems_unsigned32 oldbits=0;
int bm=0;
int cursofs=0;
char text[16+1];
#define word unsigned int
word*ptr;
Input_Message msg;


#define N_PAGES 7

#define PAGE_PRESET         0
#define PAGE_INFO           1
#define PAGE_CONFIG_CHANNEL 2
#define PAGE_CONFIG_ACTIONS 3
#define PAGE_CONFIG_VOLUMES 4
#define PAGE_CONFIG_QUANTIZ 5
#define PAGE_CONFIG_LOOPLEN 6


extern int looper_state[2][4];

int p_action,p_lr,p_num,p_param;


#define MIDI_LEARN_CC 1
#define MIDI_LEARN_KEY 2
int volatile midi_learn=0;
char volatile* volatile midi_learn_target;


char* act_name[4] = { "Play", "Loop", "Rec ", "Stop" };

char* notes[12] = { "C-", "C#", "D-", "D#", "E-", "F-", "F#", "G-", "G#", "A-", "A#", "B-" };

char* asqtz[6] = { "1/8 Beat", "1/4 Beat", "1/2 Beat", "1 Beat", "2 Beats", "4 Beats" };





#define N_SCRSVR_MSG 17

//char*screensaver[] = {
//      /*".123456789ABCDEF.123456789ABCDEF"*/
//	"idle messages...check'em out :p",
//	"Hey ! do someth-ing already !",
//	"Don't waste my  cpu clocks !!",
//	" 2 + 3 = 5",
//	"Go visit http://3564020356.org/",
  //    /*".123456789ABCDEF.123456789ABCDEF"*/
//	"sleeping...",
//	"Do u know what ?I'm happy  :|",
//	" o//  H41L  \\\\o \\o_   3R1S   _o/",
//	"idling...",
//	"snoring out loud...",
  //    /*".123456789ABCDEF.123456789ABCDEF"*/
//	"still alive ??",
//	"    Looper282   by bl0b",
//	"     Jerash           Labs",
//	"Meditation is   the Way",
//	"You're right, beZen, don't move.",
//	"Shikantaza ka",
  //    /*".123456789ABCDEF.123456789ABCDEF"*/
//	"  Music is my      aeroplane",
//	"Error in WIN.VXDnah, just kiddin",
//	"    Looper282   Jerash Labs 2005"
//};


int volatile mode=0;
int page=0;
int mainpage_init=0;


char*value2ascii(signed int value,char*buf);
void do_cursor();

Input_Message receive_input() {
//	static int oldscrsvr=-1;
	Input_Message msg=0;
	rtems_unsigned32 size,ret;
//	if(mode&&!midi_learn) {	/* disable screensaver messages when displaying main page or waiting for midi assignation */
		ret=rtems_message_queue_receive(user_input,&msg,&size,RTEMS_WAIT,EDIT_TIMEOUT);
	    	if(ret==RTEMS_TIMEOUT) {
//	    		int scrsvr;
//	    		do { scrsvr=rand()%N_SCRSVR_MSG; } while(scrsvr==oldscrsvr);
//	    		oldscrsvr=scrsvr;
//	    		display_message(screensaver[scrsvr]);
	    		return 0;
	        }
//	} else {
//		ret=rtems_message_queue_receive(user_input,&msg,&size,RTEMS_WAIT,EDIT_TIMEOUT);
//	    	if(ret==RTEMS_TIMEOUT) {
//	    		return 0;
//	        }
//	}
	return msg;
}




void msg10_accumulate(int value) {
	rtems_interval date;
	static int accum=0;

	rtems_clock_get(RTEMS_CLOCK_GET_TICKS_SINCE_BOOT,&date);
	if(date-TMR_last_msg10_accum>=TMR_ticks_per_msg10) { /* accum is old ; reset */
		accum=0;
	}
	accum+=value;
	if(date-TMR_last_msg10>=TMR_ticks_per_msg10) {
		msg=MkIMsg(MSG_VALUE_CHANGE,accum);
		accum=0;
		TMR_last_msg10=date;
		rtems_message_queue_send(user_input,&msg,MsgSz);
	}
	TMR_last_msg10_accum=date;
}



void set_parameter(int,int);
void set_memmode(int);
void set_looper_state(int,int,unsigned int);


static rtems_task panel_task(rtems_task_argument argument) {
	int v[2],i=0;
	char dbbuf[10];

	while(TRUE) {
		if (!panel_in_new_event(panel, TRUE))
		{
			TRACE("ERROR: unexpected exit waiting for new panel event.\n");
		}

		if (panel_in_potentiometer(panel, &potentiometer, &value)) {
			switch(potentiometer) {
			case PANEL01_POT_VOLUME:
//				v[0]=MkMessage(MSG_BIT_SET,N_PARAMETERS);
//				v[1]=db2coef[value];
//				dsp_write_data(dsp,v,2);
				set_parameter(N_PARAMETERS,db2coef[value]);
				midi_loopback();
				display_message("Master Volume   set to %-11.11s",value2ascii(value,dbbuf));
				break;
			case PANEL01_POT_CTRL1:
				if(mode) break;
				Preset.volumes[p_lr]=value;
//				v[0]=MkMessage(MSG_BIT_SET,p_lr);
//				v[1]=db2coef[value];
//				dsp_write_data(dsp,v,2);
				set_parameter(p_lr,db2coef[value]);
				midi_loopback();
				display_message("%-16.16sset to %-11.11s",param_names[p_lr],value2ascii(Preset.volumes[p_lr],dbbuf));
				break;
			case PANEL01_POT_CTRL2:
				if(mode) break;
				if(p_param!=-1) {
					i=2+(p_lr*4)+p_param;
					Preset.volumes[i]=value;
//					v[0]=MkMessage(MSG_BIT_SET,i);
//					v[1]=db2coef[value];
//					dsp_write_data(dsp,v,2);
					set_parameter(i,db2coef[value]);
					midi_loopback();
				}
				display_message("%-16.16sset to %-11.11s",param_names[i],value2ascii(Preset.volumes[i],dbbuf));
				break;
			case PANEL01_POT_CTRL3:
				if(mode) break;
				i=10+p_lr;
				Preset.volumes[i]=value;
//				v[0]=MkMessage(MSG_BIT_SET,i);
//				v[1]=db2coef[value];
//				dsp_write_data(dsp,v,2);
				set_parameter(i,db2coef[value]);
				midi_loopback();
				display_message("%-16.16sset to %-11.11s",param_names[i],value2ascii(Preset.volumes[i],dbbuf));
				break;
			};
			//display(15,0,"%c",value);
			//display(15,1,"%c",value+127);
			//refresh();
		} else if(panel_in_encoder(panel,&potentiometer,&value)) {
			/*TRACE("ENCODER 0x%02X %+i\n",potentiometer,value);*/
			if(!(panel_input_disabled||Panel_Mode==PANELMODE_RUN)) {
				msg10_accumulate(value);
			}
		} else if(panel_in_keypad(panel,&bits)) {
			/*TRACE("KEY BITS %8.8X\n",bits);*/
			bitsdiff=bits^oldbits;
			if(bits&bitsdiff&chamie_buttons[0]) { /* edit button was pressed */
				TRACE("Change Mode...\n");
				msg=MkIMsg(MSG_MODE_CHANGE,0);
				rtems_message_queue_send(user_input,&msg,MsgSz);
			}

			for(i=1;i<10;i++) {
				if(bits&bitsdiff&chamie_buttons[i]) {
					/*TRACE("Button #%i %ssed\n",i,bits&chamie_buttons[i]?"pres":"relea");*/
					msg=MkIMsg(i,bits&chamie_buttons[i]?1:0);
					rtems_message_queue_send(user_input,&msg,MsgSz);
				}
			}
			if(bits&bitsdiff&chamie_buttons[10]) {
				msg=MkIMsg(MSG_VALUE_UP,bits&chamie_buttons[10]?1:0);
				rtems_message_queue_send(user_input,&msg,MsgSz);
				msg10_accumulate(1);
			}
			if(bits&bitsdiff&chamie_buttons[11]) {
				msg=MkIMsg(MSG_VALUE_DOWN,bits&chamie_buttons[11]?1:0);
				rtems_message_queue_send(user_input,&msg,MsgSz);
                		msg10_accumulate(-1);
			}
			oldbits=bits;
		}
	}
}




char* note_name(int note) {
	static char ret[5]={0,0,0,0,0};
	int n=note%12;
	int o=note/12;
//	--o;
	ret[0]=notes[n][0];
	ret[1]=notes[n][1];
	if(o<10) {
		ret[2]='0'+o;
		ret[3]=' ';
	} else {
		ret[2]='1';
		ret[3]='0'+o-10;
	}
	return ret;
}


char*qtz2ascii(int qtz) {
	int n=0;
	if(qtz==72) return "3 Beats";
	if(qtz==0) return "None";
	while(qtz>3) {
		++n;
		qtz>>=1;
	}
	if(n>=6) {
		TRACE("OUPS ! mauvais qtz=%i !\n",qtz);
		return "unclear";
	}
	return asqtz[n];
}


#define VOLSCL -64.f
#define VOLFACTOR (8.f/VOLSCL)

void display_volume(int x,int y,float vol) {
	unsigned char c[2]={0,0};
	if(vol==0.f) c[0]='X';
	else
		c[0]=vol<=VOLSCL?0:7-(int)(vol*VOLFACTOR);
//	TRACE("x=%i y=%i vol=%f #%i\n",x,y,vol,c[0]);
	display(x,y,c);
}


extern int looper_state[2][4];


char*ll2str(int k,float l) {
	static char blah[4][5];
	if(l==0) return "off";
	sprintf(blah[k],"%2.2is",(int)l);
	return blah[k];
}

extern unsigned int loop_mem_size;
extern unsigned int loop_mem_base;


void display_loop_len(int n) {
	float l1=1.f,l2=1.f,l3=1.f,l4=1.f;
	float lsz=loop_mem_size*(0.125f/48000.f);
	switch(n) {
	case 0:
		l1=l2=l3=l4=lsz;
		break;
	case 1:
		l1=lsz+lsz;
		l2=lsz;
		l3=l4=lsz*0.5f;
		break;
	case 2:
		l1=lsz+lsz;
		l2=l3=lsz;
		l4=0;
		break;
	case 3:
		l1=l2=lsz+lsz;
		l3=l4=0;
		break;
	case 4:
		l1=lsz*3;
		l2=l3=lsz*0.5f;
		l4=0;
		break;
	case 5:
		l1=lsz*3;
		l2=lsz;
		l3=l4=0;
		break;
	case 6:
		l1=lsz*4;
		l2=l3=l4=0;
		break;
	default:;
	};
	display(0,1,"%s %s %s %s ",ll2str(0,l1),ll2str(1,l2),ll2str(2,l3),ll2str(3,l4));
}

void do_leds();


extern int volatile dsp_usage;
extern int volatile dsp_usage_debug[16];

void display_page(int mode,int page) {
	int i,j;
	char dbbuf[10];
	do_leds();
	if(mode) {
		if(page!=PAGE_PRESET||p_action!=1) disable_cursor();
		switch(page) {
			case PAGE_PRESET:
				switch(p_action) {
				case 0:	display(0,0,"Select Preset   ");
					display(0,1,"%3.3i: %-8.8s   ",config.p,config.presetnames[(int)config.p]);
					break;
				case 1:	display(0,0,"Rename Preset   ");
					display(0,1,"%3.3i: %-8.8s   ",config.p,config.presetnames[(int)config.p]);
					set_cursor(5+p_param,1);
					enable_cursor();
					break;
				case 2:	display(0,0,"Copy Preset   ");
					display(0,1,"%3.3i>%3.3i:%-8.8s",config.p,p_param,config.presetnames[p_param]);
					break;
				case 3:
					display(0,0,"Sure ?        ");
					display(0,1,"Gd=yes Gu=no  ");
					break;
				};
				break;
			case PAGE_INFO:
				for(i=1;i<8;i++) set_chr(i,BITMAP(i));
				//*
				display(0,0,"Loop Mem %3.1fs  ",loop_mem_size*(Preset.samplerate?1.f/32000.f:1.f/48000.f));
				display(15,0,"%c",dsp_usage>>2);
				/*/display(0,0,"[%X] %i",loop_mem_base,loop_mem_size);//*/
				//*
				display(0,1,"Samplerate %2.2ikHz",Preset.samplerate?32:48);/*/
				//display(0,1,"dsp %i %i %i %i %i  ",dsp_usage_debug[0],dsp_usage_debug[1],dsp_usage_debug[2],dsp_usage_debug[3],dsp_usage);
				display(0,1,"dsp %i %i  ",dsp_usage_debug[4],dsp_usage_debug[5]);
				//*/
				break;
			case PAGE_CONFIG_CHANNEL :
				display(0,0,"MIDI Channel    ");
				if(Preset.channel>=0)
					display(0,1,"[ % .2i ]       ",1+Preset.channel);
				else
					display(0,1,"[ Any ]         ");
				break;
			case PAGE_CONFIG_ACTIONS :
				set_chr(1,BOLD_BITMAP(p_lr?'R':'L'));
				set_chr(2,BOLD_BITMAP('1'+p_num));
				display(0,0,"Assign \1\2 [%-4.4s]",act_name[p_action]);
				i=Preset.Action_Assigns[p_lr][p_num][p_action];
				if(midi_learn)
					display(0,1,"[learn]         ");
				else
					display(0,1,"Note-O%-2.2s %4.4s    ",i&128?"ff":"n",note_name(i&127));
				break;
			case PAGE_CONFIG_VOLUMES :
				display(0,0,"%-16.16s",param_names[p_param]);
				if(p_lr) {
					display(0,1,"%-16.16s",value2ascii(Preset.volumes[p_param],dbbuf));
				} else {
					if(midi_learn)
						display(0,1,"[learn]         ");
					else
						display(0,1,"Controller #% 3.3i    ",Preset.parameter_controllers[p_param]);
				}
				break;
			case PAGE_CONFIG_QUANTIZ :
				display(0,0,"Quantization     ");
				display(0,1,"%-16.16s",qtz2ascii(Preset.beat_counter_max));
				break;
			case PAGE_CONFIG_LOOPLEN:
				display(0,0,"Mem Mode %-5s  ",p_lr?(p_lr==2?"Right":"Left"):"L/R  ");
				display_loop_len(p_lr!=1?ModeR(Preset.looplength_mode):ModeL(Preset.looplength_mode));
				break;
		};
		refresh();
	} else {
		display(0,0," L %c1  %c  %c  %c  ",p_lr?' ':'*',looper_on[0][1]?'2':' ',
			looper_on[0][2]?'3':' ',looper_on[0][3]?'4':' ');
		display(0,1," R %c1  %c  %c  %c  ",p_lr?'*':' ',looper_on[1][1]?'2':' ',
			looper_on[1][2]?'3':' ',looper_on[1][3]?'4':' ');

		for(j=0;j<2;j++) {
			for(i=0;i<4;i++) {
				if(looper_on[j][i]&&(looper_state[j][i]&STATE_BIT_REC)) {
					//c[0]='|'+127;// 0373
					display(5+3*i,j,"%c",'|'+127);
				} else if(looper_on[j][i]&&(looper_state[j][i]&STATE_BIT_LOOP)) {
					//c[0]='C'+127;// 0302
					display(5+3*i,j,"%c",'C'+127);
				} else if(looper_on[j][i]&&(looper_state[j][i]&STATE_BIT_PLAY)) {
					//c[0]='='+127;// 0274
					display(5+3*i,j,"%c",'='+127);
				}
			}
		}
		for(i=1;i<8;i++) set_chr(i,BITMAP(i));
		display_volume(0,0,Volumes[VOL_IN]);
		display_volume(2,0,Volumes[VOL_OUT]);
		display_volume(0,1,Volumes[VOL_IN+1]);
		display_volume(2,1,Volumes[VOL_OUT+1]);
		for(i=0;i<4;i++) {
			if(looper_on[0][i]&&looper_state[0][i])
				display_volume(6+3*i,0,Volumes[VOL_LOOPER+i]);
			if(looper_on[1][i]&&looper_state[1][i])
				display_volume(6+3*i,1,Volumes[VOL_LOOPER+4+i]);
		}
		if(p_param!=-1) {
			set_cursor(4+3*p_param,p_lr);
			enable_cursor();
		} else {
			disable_cursor();
		}
//		disp_unlock();
		refresh();
	}
	do_cursor();
}



void _Save_Config(char*,unsigned int);

void SelectPreset(int);

void do_page_input(int page,Input_Message msg) {
	int i;
	int l,r;
	int v[2];
	char*c;
	switch(page) {
	case PAGE_PRESET :
		switch(MsgWhat(msg)) {
		case MSG_GROUP_UP:
			if(p_action) --p_action;
			break;
		case MSG_GROUP_DOWN:
			if(p_action<3) {
				++p_action;
			} else {
				if(config.p!=p_param) {
					memcpy(&(config.P[p_param]),&(config.P[(int)config.p]),sizeof(Preset_t));
					memcpy(config.presetnames[p_param],config.presetnames[(int)config.p],NAMESIZE);
					p_action=2;
					config.p=p_param;
					Save_Config(config.P[(int)config.p]);
					Save_Config(config.presetnames[p_param]);
				}
			}
			break;
		default:;
			switch(p_action) {
			case 0:
				switch(MsgWhat(msg)) {
				case MSG_VALUE_CHANGE:
					SelectPreset(config.p+MsgVal(msg));
					break;
				default:;
				};
				break;
			case 1:
				switch(MsgWhat(msg)) {
				case MSG_VALUE_CHANGE:
					c=strchr(preset_name_chars,(int)config.presetnames[(int)config.p][p_param]);
					if(c)
						l=c-preset_name_chars;
					else
						l=0;
					l+=MsgVal(msg);
					if(l<0) l=0;
					if(l>=strlen(preset_name_chars))
						l=strlen(preset_name_chars)-1;
					config.presetnames[(int)config.p][p_param]=preset_name_chars[l];
					Save_Config(config.presetnames[(int)config.p][p_param]);
					break;
				case MSG_PARAM_UP:
					p_param++;
					p_param%=NAMESIZE;
					break;
				case MSG_PARAM_DOWN:
					p_param+=NAMESIZE-1;
					p_param%=NAMESIZE;
					break;
				default:;
				};
				break;
			case 2:
				switch(MsgWhat(msg)) {
				case MSG_VALUE_CHANGE:
					p_param+=MsgVal(msg);
					if(p_param<0) p_param=0;
					else if(p_param>127) p_param=127;
					break;
				/*case MSG_PARAM_UP:
					p_param++;
					p_param%=NAMESIZE;
					break;
				case MSG_PARAM_DOWN:
					p_param+=NAMESIZE-1;
					p_param%=NAMESIZE;
					break;*/
				default:;
				};
				break;
			default:;
			};
			break;
		};
		break;
	case PAGE_CONFIG_CHANNEL :
		switch(MsgWhat(msg)) {
		case MSG_VALUE_CHANGE:
			Preset.channel+=MsgVal(msg);
			if(Preset.channel<-1)
				Preset.channel=-1;
			if(Preset.channel>15)
				Preset.channel=15;
			set_channel();
			break;
		default:;
		};
		break;
	case PAGE_CONFIG_ACTIONS :
		switch(MsgWhat(msg)) {
		case MSG_PARAM_UP:
		case MSG_PARAM_DOWN:
			midi_learn&=1;
			midi_learn^=1;
			midi_learn_target=&(Preset.Action_Assigns[p_lr][p_num][p_action]);
			break;
		case MSG_VALUE_CHANGE:
#if 1
			r=Preset.Action_Assigns[p_lr][p_num][p_action];
			//i=r&128?1:0;
			//config.NoteEv[i][r&127]=(unsigned int)-1;
			r+=MsgVal(msg);
			r&=255;
//			i=(r&128)?1:0;
			//config.NoteEv[i][r&127]=l;
			Preset.Action_Assigns[p_lr][p_num][p_action]=r;
//			reset_noteev();
			Save_Config(Preset.Action_Assigns[p_lr][p_num][p_action]);
#endif
			break;
		case MSG_GROUP_UP:
			midi_learn=0;
			i=p_lr*4+p_num;
			++i;
			if(i>7) i=7;
			if(i<0) i=0;
			p_lr=i&4?1:0;
			p_num=i&3;
			break;
		case MSG_GROUP_DOWN:
			midi_learn=0;
			i=p_lr*4+p_num;
			--i;
			if(i>7) i=7;
			if(i<0) i=0;
			p_lr=i&4?1:0;
			p_num=i&3;
			break;
		case MSG_PAGE_UP:
			midi_learn=0;
			if(p_action<3)
				++p_action;
			break;
		case MSG_PAGE_DOWN:
			midi_learn=0;
			if(p_action>0)
				--p_action;
			break;
		default:;
		};
		break;
	case PAGE_CONFIG_VOLUMES :
		switch(MsgWhat(msg)) {
		case MSG_VALUE_CHANGE:
			if(p_lr) {
				Preset.volumes[p_param]+=MsgVal(msg);
				/*if(Preset.volumes[p_param]<0)
					Preset.volumes[p_param]=0;
				if(Preset.volumes[p_param]>127)
					Preset.volumes[p_param]=127;*/
				if(Preset.volumes[p_param]&128)
					Preset.volumes[p_param]=MsgVal(msg)&128?0:127;
//				v[0]=MSG_BIT_SET|(p_param*256);
//				v[1]=db2coef[(int)Preset.volumes[p_param]];
//				dsp_write_data(dsp,v,2);
				set_parameter(p_param,db2coef[value]);
				midi_loopback();
			} else {
				Preset.parameter_controllers[p_param]+=MsgVal(msg);
				Preset.parameter_controllers[p_param]&=127;
			}
			Save_Config(Preset.parameter_controllers[p_param]);
			break;
		case MSG_PAGE_UP:
		case MSG_PAGE_DOWN:
			p_lr=!p_lr;
			break;
		case MSG_PARAM_UP:
		case MSG_PARAM_DOWN:
			if(!p_lr) {
				midi_learn&=2;
				midi_learn^=2;
				midi_learn_target=&(Preset.parameter_controllers[p_param]);
			}
			break;
		case MSG_GROUP_UP:
			midi_learn=0;
			if(p_param<N_PARAMETERS-1)
				++p_param;
			else
				p_param=0;
			break;
		case MSG_GROUP_DOWN:
			midi_learn=0;
			if(p_param>0)
				--p_param;
			else
				p_param=N_PARAMETERS-1;
			break;
		default:;
		};
		break;
	case PAGE_CONFIG_QUANTIZ :
		switch(MsgWhat(msg)) {
		case MSG_VALUE_CHANGE:
			i=MsgVal(msg);
			if(i<0) {
				while(Preset.beat_counter_max>3&&i) {
					if(Preset.beat_counter_max>24)
						Preset.beat_counter_max-=24;
					else
						Preset.beat_counter_max>>=1;
					++i;
				}
				if(i) Preset.beat_counter_max=0;
			} else {
				if(!Preset.beat_counter_max) {
					Preset.beat_counter_max=3;
					--i;
				}
				while(Preset.beat_counter_max<96&&i) {
					if(Preset.beat_counter_max>=24)
						Preset.beat_counter_max+=24;
					else
						Preset.beat_counter_max<<=1;
					--i;
				}
			}
			Save_Config(Preset.beat_counter_max);
			break;
		default:;
		};
		break;
	case PAGE_CONFIG_LOOPLEN:
		switch(MsgWhat(msg)) {
		case MSG_VALUE_CHANGE:
			l=ModeL(Preset.looplength_mode);
			r=ModeR(Preset.looplength_mode);
			switch(p_lr) {
			case 0:
				r+=MsgVal(msg);
			case 1:
				l+=MsgVal(msg);
				break;
			case 2:
				r+=MsgVal(msg);
				break;
			};
			if(l>N_MODES-1) l=N_MODES-1;
			if(r>N_MODES-1) r=N_MODES-1;
			if(l<0) l=0;
			if(r<0) r=0;
//			i=MkMessage(MSG_BIT_SET|65,MkMode(l,r));
//			dsp_write_data(dsp,&i,1);
			set_memmode(MkMode(l,r));
			break;
		case MSG_GROUP_UP:
			++p_lr;
			p_lr%=3;
			break;
		case MSG_GROUP_DOWN:
			p_lr+=2;
			p_lr%=3;
			break;
		default:;
		};
	};
}


void dsp_fifo_write(rtems_unsigned32);

extern rtems_interval displaying_message;

static rtems_task ihm_task(rtems_task_argument argument) {
	Input_Message msg;
	rtems_interval date;
	while(TRUE) {
		msg=receive_input();
		if(MsgWhat(msg)==MSG_MODE_CHANGE) {
			mode^=1;
			midi_learn=p_lr=p_num=p_action=p_param=0;
			mainpage_init=0;
			clear();
		} else {
			if(mode) {
				if(MsgWhat(msg)==MSG_PART_UP) {
					if(page) {
						--page;
						midi_learn=p_lr=p_num=p_action=p_param=0;
						clear();
					} else {
						page=N_PAGES-1;
						midi_learn=p_lr=p_num=p_action=p_param=0;
					}
				} else if(MsgWhat(msg)==MSG_PART_DOWN) {
					if(page<N_PAGES-1) {
						++page;
						midi_learn=p_lr=p_num=p_action=p_param=0;
						clear();
					} else {
						page=0;
						midi_learn=p_lr=p_num=p_action=p_param=0;
					}
				} else
					do_page_input(page,msg);
			} else {
				switch(MsgWhat(msg)) {
				case MSG_PART_UP:	SelectPreset((config.p+1)&127); break;
				case MSG_PART_DOWN:	SelectPreset((config.p-1)&127); break;
				case MSG_GROUP_UP:	if(p_param==0) p_lr^=1; p_param=0; break;
				case MSG_PAGE_UP:	if(p_param==1) p_lr^=1; if(looper_on[p_lr][1]) p_param=1; break;
				case MSG_PARAM_UP:	if(p_param==2) p_lr^=1; if(looper_on[p_lr][2]) p_param=2; break;
				case MSG_VALUE_UP:	if(p_param==3) p_lr^=1; if(looper_on[p_lr][3]) p_param=3; break;
				case MSG_GROUP_DOWN:	if(p_param!=-1) set_looper_state(p_lr,p_param,STATE_BIT_PLAY); midi_loopback(); break;
				case MSG_PAGE_DOWN:	if(p_param!=-1) set_looper_state(p_lr,p_param,STATE_BIT_PLAY|STATE_BIT_LOOP); midi_loopback(); break;
				case MSG_PARAM_DOWN:	if(p_param!=-1) set_looper_state(p_lr,p_param,STATE_BIT_REC); midi_loopback(); break;
				case MSG_VALUE_DOWN:	if(p_param!=-1) set_looper_state(p_lr,p_param,0); midi_loopback(); break;
				};
			}
		}
		rtems_clock_get(RTEMS_CLOCK_GET_TICKS_SINCE_BOOT,&date);
		if(date>=displaying_message+MESSAGE_HOLD) {
			clear();
			display_page(mode,page);
		}

	}
}



rtems_id ihm_task_id,panel_task_id;



rtems_boolean create_ihm_task() {
	panel=panel_init();
    rtems_clock_get(RTEMS_CLOCK_GET_TICKS_PER_SECOND,&TMR_ticks_per_s);
    TRACE("%u ticks per second, so %f hours before wrap\n",TMR_ticks_per_s,(float)(((unsigned int)0xFFFFFFFF)/3600.f/TMR_ticks_per_s));
    TMR_ticks_per_msg10=TMR_ticks_per_s/25; /* 25 FPS... why not... */
	if (!panel) {
		TRACE("ERROR: cannot access the panel.\n");
		return 1;
/*		rtems_task_delete(RTEMS_SELF);*/
	}
//    rtems_semaphore_create(rtems_build_name('P','M','T','X'),1,0,0,&panel_lock);

    TRACE("\n\nwordsize = %lu floatsize = %lu\n\n\n",sizeof(word),sizeof(float));

	rtems_message_queue_create(rtems_build_name('I','N','M','Q'),32,2,0,&user_input);

	rtems_task_create(rtems_build_name('P','A','N','L'),
			PANEL_PRIO,RTEMS_MINIMUM_STACK_SIZE,
			RTEMS_DEFAULT_ATTRIBUTES,
			RTEMS_DEFAULT_MODES,&panel_task_id);
//	rtems_task_start(panel_task_id, panel_task,(rtems_task_argument)0);

	return !(disp_init()&&RTEMS_SUCCESSFUL==rtems_task_create(rtems_build_name('_','I','H','M'),
						PANEL_PRIO,RTEMS_MINIMUM_STACK_SIZE,
						RTEMS_DEFAULT_ATTRIBUTES,
						RTEMS_DEFAULT_MODES,&ihm_task_id));
}



rtems_boolean start_ihm_task() {
	return RTEMS_SUCCESSFUL==rtems_task_start(panel_task_id, panel_task,(rtems_task_argument)0)
		&&
	       RTEMS_SUCCESSFUL==rtems_task_start(ihm_task_id, ihm_task,(rtems_task_argument)0);
}









