#include "display.h"
#include "char_bitmaps.h"
#include "looper.h"

extern rtems_id user_input;

rtems_boolean create_ihm_task();
rtems_boolean start_ihm_task();

typedef struct {
	char Action_Assigns[2][4][4]; /* left/right, 4 loopers, 4 actions (play_once play_loop stop record)
					assign is 1:7 on/off note# */
	char parameter_controllers[N_PARAMETERS];
	char volumes[N_PARAMETERS];
	char channel;
	rtems_unsigned16 beat_counter_max;
	char looplength_mode;
	char samplerate;
	char ___pad___[3];
} Preset_t;	/* 64 bytes */


#define N_PRESETS 128
#define NAMESIZE 8

typedef struct {
	rtems_unsigned32 magic;
	char p;
	char presetnames[N_PRESETS][NAMESIZE+1];
	Preset_t P[N_PRESETS];
} Config_t;

#define N_MODES 7

extern float Volumes[12];

extern Config_t config;

#define Preset config.P[(int)config.p]

extern int volatile midi_learn;
extern char volatile* volatile midi_learn_target;

void set_channel();

#define Save_Config(x) _Save_Config((char*)&(x),sizeof(x))