/* looper.h */


typedef unsigned int Message;

/* crunch and decrunch a message and its param */
#define MkMessage(_msg,_param) ((_param<<8)|_msg)
#define Msg(_msg) (_msg&0xFF)
#define Param(_msg) (_msg>>8)

#define LEFT 0
#define RIGHT 1

/* bits for msg */
#define MSG_BIT_RIGHT (1<<3)
#define MSG_MASK_LOOPER 0x03
#define MSG_MASK_STATE  0x70
#define MSG_STATE_STOP  0x00
#define STATE_BIT_PLAY 0x10
#define STATE_BIT_LOOP 0x20
#define STATE_BIT_REC  0x40
#define MSG_BIT_SET    0x80


#define ON  1
#define OFF 0

#define CONF_MAGIC 0x23b10b42

#define N_PARAMETERS 12

#define N_MODES 7

#define MkAssign(lr,num,stbits) ((lr<<3)|num|stbits)
#define AssignLR(ass) (ass>>3)
#define AssignNum(ass) (ass&0x3)
#define AssignState(ass) (ass&MSG_MASK_STATE)


#define MkMode(_l,_r) ((_r<<3)|_l)
#define ModeL(_lr) (_lr&7)
#define ModeR(_lr) (_lr>>3)

